﻿using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;

namespace TabStyling
{
    public partial class Form1 : Form
    {
        private List<DockableControlPane> allDockableControlPanes;

        public Form1()
        {
            InitializeComponent();
            allDockableControlPanes = new List<DockableControlPane>();
            CreateForms();
        }

        private void CreateForms()
        {
            IList<DockAreaPane> floatingDockAreas = CreateAllFloatingDockAreas();

            ultraDockManager1.DockAreas.AddRange(floatingDockAreas.ToArray());
            foreach (var allDockableControlPane in allDockableControlPanes)
            {
                allDockableControlPane.IsMdiChild = true;
            }
        }

        private IList<DockAreaPane> CreateAllFloatingDockAreas()
        {
            return new List<DockAreaPane>
                       {
                           CreateFloatingDockArea("UT A"),
                           CreateFloatingDockArea("UT B"),
                           CreateFloatingDockArea("UT C")
                       };
        }

        private DockAreaPane CreateFloatingDockArea(string key)
        {
            DockableControlPane dockableControlPane = CreateDockableControlPane(key);
            var dockAreaPane = new DockAreaPane(DockedLocation.Floating);
            dockAreaPane.Panes.Add(dockableControlPane);
            return dockAreaPane;
        }

        private DockableControlPane CreateDockableControlPane(string key)
        {
            var control = new TreeView();
            Controls.Add(control);
            var dockableControlPane = new DockableControlPane(control);
            dockableControlPane.Key = key;
            dockableControlPane.Text = key;
            
            allDockableControlPanes.Add(dockableControlPane);
            return dockableControlPane;
        }
    }
}